<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leandroafonso
 * Date: 05/02/14
 * Time: 16:17
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Logic;


use Folha\Entities\GpeVinculom;
use Teknisa\Logic\Exception;

//use Folha\Entities\Base\FpaFormcnab;

class Cnab240 {
    protected $nrorg;
    protected $competencia;
    protected $nrmodalidade;
    protected $nrformcnab;
    protected $idativo;
    protected $idprocvinculo;
    protected $idgerameiomag;
    protected $idteste;
    protected $nmformcnab;
    protected $dtpagamento;
    protected $nrhierarqorg;
    protected $dsordem;
    protected $dsinicio;
    protected $dsfim;
    //protected $cdbanco;
    //protected $cdagencia;
    //protected $cdcontcorr;
    //protected $nrtpcontcorr;
    protected $nrtipomoviment;
    protected $codconvenio;
    protected $nreventom;
    protected $nreventom__label;
    protected $nrvinculom;
    protected $cdmatricula;
    protected $cdgrupoper;
    protected $cdgrupoper__label;
    protected $idtpinschierarq;
    protected $nrpessoarespons;
    protected $nrpessoarespons__label;
    protected $nrestrutrespons;
    protected $idtpinscrespons;
    protected $idutildtpgtoitem;

    protected $vrtotal;

    protected $vinculos;
    protected $estruturas;

    protected $nomeArquivo = '';
    protected $caminhoRelativo = '';
    protected $caminhoRelCompleto = '';
    protected $nrSeqArquvio;

    public function __construct($params){
        $this->nrorg = \Ambiente::getNrorgTrabalho();
        $this->competencia = \FPA::getDtCompetencia();
        $this->nrmodalidade = \FPA::getNrModalidadeCalculo();
        $this->nrformcnab=$params['NRFORMCNAB'];
        $this->idativo=$params['IDATIVO'];
        $this->idprocvinculo=$params['IDPROCVINCULO'];
        $this->idgerameiomag=$params['IDGERAMEIOMAG'];
        $this->idteste=$params['IDTESTE'];
        $this->nmformcnab=$params['NMFORMCNAB'];
        $this->dtpagamento=$params['DTPAGAMENTO'];
        $this->nrhierarqorg=$params['NRHIERARQORG'];
        $this->dsordem=$params['DSORDEM'];
        $this->dsinicio=$params['DSINICIO'];
        $this->dsfim=$params['DSFIM'];
        $this->cdbanco=$params['CDBANCO'];
        //$this->cdagencia=$params['CDAGENCIA'];
        //$this->cdcontcorr=$params['CDCONTCORR'];
        //$this->nrtpcontcorr=$params['NRTPCONTCORR'];
        $this->nrtipomoviment=$params['NRTIPOMOVIMENT'];
        $this->codconvenio=$params['CODCONVENIO'];
        $this->nreventom=$params['NREVENTOM'];
        $this->nreventom__label=$params['NREVENTOM__LABEL'];
        $this->nrvinculom=$params['NRVINCULOM'];
        $this->cdmatricula=$params['CDMATRICULA'];
        $this->cdgrupoper=$params['CDGRUPOPER'];
        $this->cdgrupoper__label=$params['CDGRUPOPER__LABEL'];
        $this->idtpinschierarq=$params['IDTPINSCHIERARQ'];
        $this->nrpessoarespons=$params['NRPESSOARESPONS'];
        $this->nrpessoarespons__label=$params['NRPESSOARESPONS__LABEL'];
        $this->nrestrutrespons=$params['NRESTRUTRESPONS'];
        $this->idtpinscrespons=$params['IDTPINSCRESPONS'];
        $this->idutildtpgtoitem=$params['IDUTILDTPGTOITEM'];

        $this->vrtotal = 0;
    }

    public function prepara(){
        //Verifica se já existe magnética para a competência informada
        //$magnetico = \Folha\Entities\FpaCnabmagnet::getRepository();
        $magnetico = new \FpaCnabmagnetEntity();
        $registros = $magnetico->retornaRegistros($this->competencia, $this->nrorg, $this->cdbanco, $this->nrtipomoviment);
        $aux = 0;
        foreach($registros as $nada){ //Conta quantos registros. Espera-se 0 registros e arquivo de não teste. Caso contrário deve ser feito um retroceso.
            $aux +=1;
        }

        if($aux > 0 && $this->idteste == 'N' && $this->idgerameiomag == 'S'){
            throw new \Exception("Existe um magnético para esta competência, tipo de movimento e número do banco. Se deseja prosseguir retroceda o cálculo.");
        }

        //$aux = $magnetico->findOneByNRORGAndMESCOMPTENCIA($this->nrorg, $this->competencia);

        //Não há magnético. Continuando com as rotinas para a geração do mesmo
        $rpFormcnab = \Folha\Entities\FpaFormcnab::getRepository();

        // felipesantos - 09/04/2015 : verificação se utiliza data de pagamento
        $dtPagamento = $this->idutildtpgtoitem==='S' ? $this->dtpagamento : null;

        $this->vinculos = $rpFormcnab->retornaRegistrosVinculo($this->nrorg, $this->competencia, $this->nrmodalidade, $this->nreventom,$this->nrtipomoviment,
            $this->cdbanco, $this->dsordem, $this->dsinicio, $this->dsfim, $dtPagamento);

        $this->estruturas = $rpFormcnab->retornaRegistroEmpresa($this->nrorg,$this->nrestrutrespons, $this->competencia);

        foreach($this->vinculos as $vinculo){
            $this->vrtotal += $vinculo['VREVENTOFOLHA'];
        }
    }

    public function retrocede(){
        $magnetico = new \FpaCnabmagnetEntity();
        $magnetico->retroceder($this->nrorg, $this->competencia, $this->cdbanco, $this->nrtipomoviment);
    }

    /*
     * Trunca ou completa com caracteres um registro de acordo com seu tamanho e configurações (parâmetros).
     * Também alinha a esquerda ou direita conforme '$alinhaEsquerda'
     * Otimizar este código!
     */
    protected function completaCaracter($entrada, $tamanho, $caracter, $alinhaEsquerda = true){
        $tam = strlen($entrada);    //Get no tamanho da string de entrada

        if($tam > $tamanho)         //Verifica se a string de entrada não é maior que o campo (defindo em $tamanho)
            return substr($entrada, 0, $tamanho);   //Truncando a string para $tamanho

        $caracter = substr($caracter, 0, 1);    //Garante que caracter tem apenas uma posição
        $buf = '';  //variável auxiliar para montar o registro

        if($alinhaEsquerda)     //Verifica se o texto deve ficar alinhado à esquerda
            $buf = $entrada;    //Adiciona o texto primeiro

        $tamanho = $tamanho - $tam;     //Ajuste para o loop a seguir
        for($i = 0; $i < $tamanho; ++$i){   //Adiciona os espaços, se necessário
            $buf .= $caracter;
        }

        if(!$alinhaEsquerda)    //Verifica se o texto deve ficar alinhado à direita
            $buf .= $entrada;   //Adiciona o texto após os espaços

        return $buf;
    }

    protected function getCaminhoOrg(){
        return $this->nrorg.'\\';
    }

    //Remove os caracteres BOM da string dada. Mais informações em http://en.wikipedia.org/wiki/Byte_order_mark
    public function remove_utf8_bom($text)
    {
        $bom = pack('H*','EFBBBF');
        $text = preg_replace("/^$bom/", '', $text);
        return $text;
    }
}
