<?php
namespace Geral\Entities;


/**
 * @method \Geral\Entities\Inventestcego[] findByInventarioPendente static proxy pro repositorio
 */
class Inventestcego extends Base\Inventestcego
{


    CONST FORMATEDATE = 'Y-m-d';


    /**
     * Consulta a maior data de contagem anterior a data de processamento de uma determinada filial.
     *
     * @param $nrorg
     * @param $filial
     * @param $dtProc
     *
     * @return bool|string
     */
    public function maiorDataContagemInvent($nrorg, $filial, $dtProc){
        /** @var $obj \Geral\Entities\Inventestcego */
        $obj = self::getObjectByWhere(
            'NRORG = ? AND CDFILIAL = ? AND DTCONTAGEM < ?',
            array($nrorg, $filial, $dtProc,),
            'DTCONTAGEM DESC'
        );

        if (is_object($obj) === true)
            return $obj->getDtcontagem()->format(self::FORMATEDATE);
        return false;
    }


}