<?php

namespace Importacao\Logic\Integracao\Mastermaq\Classes;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Migracao;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Entities\Vinculo;

class GeraVinculo extends Migracao
{

    private $end_banco;
    
    public function __construct($path_vinculo, $path_banco) {
        parent::__construct($path_vinculo);
        $this->end_banco = $path_banco;
        $this->file_name = 'Vinculo';
        $this->setColumns();
    }
    
    public function createInfo($info) {

        $bancos = $this->infoBanco($this->end_banco);
        
        
        foreach ($info as $reg){
            
            $banco = $this->buscaAgencia($reg['BANCO'], $bancos);
            
            $vinculo = new Vinculo();

            $vinculo->setDtexamed($reg['EXAME_MED']);
            $vinculo->setDtadmiss($reg['ADMISSAO']);
            $vinculo->setDtrecisa($reg['RESCISAO']);
            $vinculo->setNrvuncul($reg['FUNCC']);
            $vinculo->setSitvincu($reg['SITUACAO']);
            $vinculo->setEscavinc($reg['TIPO_HOR']);
            $vinculo->setContsind($reg['CSIND']);
            $vinculo->setNmfuncio($reg['NOME']);
            $vinculo->setEstcivil($reg['EST_CIVIL']);
            $vinculo->setNrcpf($reg['CPF']);
            $vinculo->setNrctps($reg['CARTEIRA']);
            $vinculo->setSerictps($reg['SERIE']);
            $vinculo->setUfctps($reg['UF_CP']);
            $vinculo->setNrrg($reg['CI']);
            $vinculo->setNrpispas($reg['PIS']);
            $vinculo->setNrtitele($reg['TITELEIT']);
            $vinculo->setNrsesele($reg['SECAOELE']);
            $vinculo->setNrzonele($reg['ZONA']);
            $vinculo->setNrcnh($reg['CARTHABIL']);
            $vinculo->setCategcng($reg['TIPOHABIL']);
            $vinculo->setNrcerres($reg['CERTIFIC']);
            $vinculo->setCtcerres($reg['CATGRESV']);
            $vinculo->setRaca($reg['RACA']);
            $vinculo->setDtnascim($reg['NASCIMENTO']);
            $vinculo->setSexo($reg['SEXO']);
            $vinculo->setCodbanco($banco['BANCO']);
            $vinculo->setCdagenci($banco['AGENCIA']);
            $vinculo->setCdconcor($reg['CONTA']);
            $vinculo->setNasciona($reg['NACIONAL']);
            $vinculo->setEstado($reg['UF']);
            $vinculo->setMunicipi($reg['CIDADE']);
            $vinculo->setTpdemiss($reg['MOT_RESC']);
            $vinculo->setLogradou();
            $vinculo->Cep = $reg['CEP'];
            $vinculo->setEndereco($reg['ENDERECO']);
            $vinculo->setBairro($reg['BAIRRO']);
            $vinculo->setTpvincul($reg['FUNC_SOCIO']);
            $vinculo->setDtpriadm($reg['ANO_CHEG']);
            $vinculo->setOcupacao($reg['FUNCAO']);
            $vinculo->setVincempr($reg['VINCULO']);
            $vinculo->setTpadmiss($reg['TIPO_ADM']);
            $vinculo->setDependir($reg['DEPEND']);
            $vinculo->setDependsf($reg['DEPFILHOS']);
            $vinculo->setModasala($reg['DESC_TPSAL']);
            $vinculo->setGrauinst($reg['INSTRUCAO']);
            $vinculo->setEstrsind($reg['SINDICATO']);
            $vinculo->setDicontex($reg['DIAS_CEXP']);
            $vinculo->setDicnexpr($reg['PROG_CEXP']);
            $vinculo->setDtavtrct();
            $vinculo->setObsRecis();
            $vinculo->setDtavipre();
            $vinculo->setTpmovtra();
            $vinculo->setFimcontd();
            $vinculo->setNumero();
            $vinculo->setRefeEnde();
            $vinculo->setTpconcor();
            $vinculo->setMotrecis();
            $vinculo->setDtfgts();
            $vinculo->setDtapfgts();
            $vinculo->setTppagame();
            $vinculo->setEstrtrab($this->file_name_ent);
            $vinculo->setEstrgere($this->file_name_ent);
            $vinculo->setPais();
            $vinculo->setTpremune();
            $vinculo->setMescompe();
            $vinculo->setDtemctps($reg['DATA_CP']);            
            $vinculo->setDtpispas($reg['DATA_PIS']);
            $vinculo->setUfrg($reg['UF_CP']);
            $vinculo->setOrgexprg($reg['ORGAOREG']);
            $vinculo->setDtexperg($reg['DATA_CI']);
            $vinculo->setDtvalcnh();
            $vinculo->setCodipais('0055');
            $vinculo->setSiglaEst($reg['UF_NATURAL']);
            $vinculo->setCdmunici($reg['NATURAL']);
            $vinculo->setMultvinc();
            $vinculo->setNrctbind();
            $vinculo->setDtbasfer();

            $this->objects[] = $vinculo;   
        }
    }
    public function setColumns() {
        $this->columns[] = 'Data Admissão';
        $this->columns[] = 'Data Rescisão';
        $this->columns[] = 'Nr. Vínculo';
        $this->columns[] = 'Situ. Funcional';
        $this->columns[] = 'Escala Trabalho';
        $this->columns[] = 'Mês Competência';
        $this->columns[] = 'Contribuiçao Sind.';
        $this->columns[] = 'Nome';
        $this->columns[] = 'Estado Civil';
        $this->columns[] = 'CPF';
        $this->columns[] = 'CTPS';
        $this->columns[] = 'Série CTPS';
        $this->columns[] = 'UF CTPS';
        $this->columns[] = 'Emissao CTPS';
        $this->columns[] = 'PIS PASEP';
        $this->columns[] = 'Data de Cadastro do PIS';
        $this->columns[] = 'Carteira De Identidade';
        $this->columns[] = 'Orgão Emissor Carteira De Identidade';
        $this->columns[] = 'UF Carteira Identidade';
        $this->columns[] = 'Data de Emissão Carteira de Identidade';
        $this->columns[] = 'Título de eleitor';
        $this->columns[] = 'Seção de Votacão';
        $this->columns[] = 'Zona de Votação';
        $this->columns[] = 'CNH';
        $this->columns[] = 'Vencimento CNH';
        $this->columns[] = 'TIPO CNH';
        $this->columns[] = 'Certificado Reservista';
        $this->columns[] = 'Categoria Militar';
        $this->columns[] = 'RACA';
        $this->columns[] = 'PaÍs';
        $this->columns[] = 'Estado';
        $this->columns[] = 'Naturalidade';
        $this->columns[] = 'Data de Nascimento';
        $this->columns[] = 'Sexo';
        $this->columns[] = 'Tipo Remuneração';
        $this->columns[] = 'Banco';
        $this->columns[] = 'Agência';
        $this->columns[] = 'Conta Corrente';
        $this->columns[] = 'Tp Conta Corrente';
        $this->columns[] = 'Nacionalidade';
        $this->columns[] = 'Tp. Pagamento';
        $this->columns[] = 'Estrutura Trabalho';
        $this->columns[] = 'Estrutura Gerencial';
        $this->columns[] = 'País End';
        $this->columns[] = 'Estado End';
        $this->columns[] = 'Municipio End';
        $this->columns[] = 'Logradouro';
        $this->columns[] = 'Endereço';
        $this->columns[] = 'Número';
        $this->columns[] = 'Nome do Bairro';
        $this->columns[] = 'Complemento';
        $this->columns[] = 'Tipo Vínculo Mestre';
        $this->columns[] = 'Tipo de Demissão';
        $this->columns[] = 'Data FGTS';
        $this->columns[] = 'Dt. Aposentadoria FGTS';
        $this->columns[] = 'Data Primeira Admissão';
        $this->columns[] = 'Ocupação';
        $this->columns[] = 'Múltiplos Vínculos';
        $this->columns[] = 'Nr. Contrib. Individual';
        $this->columns[] = 'Motivo da Rescisão';
        $this->columns[] = 'Observação Rescisão';
        $this->columns[] = 'Data Aviso Prévio';
        $this->columns[] = 'Tp. Mov. Transferência';
        $this->columns[] = 'Fim Contrato Determinado';
        $this->columns[] = 'Vínculo Empregatício';
        $this->columns[] = 'Tipo Admissão';
        $this->columns[] = 'Dt. Base Férias';
        $this->columns[] = 'Dependentes IR';
        $this->columns[] = 'Dependentes Sal Fam';
        $this->columns[] = 'Modalidade Salário';
        $this->columns[] = 'Grau Instrucao';
        $this->columns[] = 'Estrutura Sindical';
        $this->columns[] = 'Dias Contrato Exp.';
        $this->columns[] = 'Dias Contrato Exp. Prorr';
        $this->columns[] = 'Dt. Exame Médico';
        $this->columns[] = 'Dt. Aviso TRCT';
        $this->columns[] = 'CEP';
    }

    /**
     *
     * @param $codBanco
     * @param array $bancos
     * @internal param String $func
     * @return array
     */
    private function buscaAgencia($codBanco, $bancos)
    {
        $info = array();
        foreach ($bancos as $banco) {
            if($banco['BANCO'] == $codBanco){
                $info['BANCO'] = $banco['COD_BANCO'];
                $info['AGENCIA'] = $banco['AG_FUNC'];

                return $info;
            }
        }
    }

    /**
     * 
     * @param String $end
     * @return array
     */
    private function infoBanco($end)
    {
        $this->connect($end);
        $bancos = $this->getInfo_();
        
        $new = array();
        foreach ($bancos as $banco){
            $aux = array();
            
            $aux['BANCO'] = $banco['BANCO'];
            $aux['COD_BANCO']= $banco['COD_BANCO'];
            $aux['AG_FUNC'] = $banco['AG_FUNC'];
            
            $new[] = $aux;
        }
        return $new;
        
    }
}

?>
