<?php

namespace Services\Logic\IntegracaoPm;

class Tarefa extends IntegracaoPmLogic
{
    protected $project;
    protected $name;
    protected $description;
    protected $start;
    protected $end;
    protected $resourceEmail;
    protected $parent;

    public function __construct() {
        $url = $this->getUtlServicoPm();
        if (!defined("ADD_TASK_URL")) define("ADD_TASK_URL", $url."/addTask");
        if (!defined("FIND_TASK_URL")) define("FIND_TASK_URL", $url."/findTaskByUser");
    }

    public function getProject() {
        return $this->project;
    }

    public function setProject($project) {
        $this->project = $project;
    }

    public function getName() {
        return $this->name;
    }

    public function setName($name) {
        $this->name = $name;
    }

    public function getDescription() {
        return $this->description;
    }

    public function setDescription($description) {
        $this->description = $description;
    }

    public function getStart() {
        return $this->start;
    }

    public function setStart($start) {
        $this->start = $start;
    }

    public function getEnd() {
        return $this->end;
    }

    public function setEnd($end) {
        $this->end = $end;
    }

    public function getResourceEmail() {
        return $this->resourceEmail;
    }

    public function setResourceEmail(array $resourceEmail) {
        $this->resourceEmail = $resourceEmail;
    }

    public function getParent() {
        return $this->parent;
    }

    public function setParent($parent) {
        $this->parent = $parent;
    }

    private function getArray() {
        $tarefa = array(
            "PROJECT"     => $this->project,
            "NAME"        => $this->name,
            "DESCRIPTION" => $this->description);

        if (!empty($this->start)) $tarefa["START"] = $this->start;
        if (!empty($this->end)) $tarefa["END"] = $this->end;
        if (!empty($this->resourceEmail)) $tarefa["RESOURCE"] = $this->resourceEmail;
        if (!empty($this->parent)) $tarefa["PARENT"] = $this->parent;

        return $tarefa;
    }

    public function salvar() {
        $data = array('requestType' => 'DataSet', 'dataset'=> array(self::getArray()));
        $response = parent::executeCurl(constant("ADD_TASK_URL"), $data, parent::getHeader());
        if (isset($response["messages"])) {
            throw new \Exception($response["messages"][0]["message"]);
        }
        else {
            return $response["dataset"]["tasks"][0]["ID"];
        }
    }

    public function salvarVarias($tarefas) {
        $data = array('requestType' => 'DataSet', 'dataset'=> $tarefas);
        $response = parent::executeCurl(constant("ADD_TASK_URL"), $data, parent::getHeader());
        if (isset($response["messages"])) {
            throw new \Exception($response["messages"][0]["message"]);
        }
        else {
            return $response["dataset"]["tasks"];
        }
    }

    public function buscarPorOperador($resourceEmail, $beginDate = null, $endDate = null) {
        $array = array(
            "RESOURCE" => $resourceEmail,
            "BEGIN_DATE" => $beginDate,
            "END_DATE" => $endDate);

        $data = array('requestType' => 'Row', 'row'=> $array);
        $response = parent::executeCurl(constant("FIND_TASK_URL"), $data, parent::getHeader());
        return $response["dataset"]["tasks"];
    }

}